/*********************************************************************

  Filename:  dbl_sp.cpp
  Chapter:   D      Appendix D - Input/Output
  Section:   D.5    Files
  Compiler:  Borland C++     Version 3.1       Summer 1993

  Ira Pohl   Object Oriented Programming Using C++

*********************************************************************/

//  Title: double_space

//dbl_sp: a program to double space a file
//Usage: executable  f1 f2
//f1 must be present and readable
//f2 must be writable if it exists


#include <fstream.h>     //includes iostream.h
#include <stdlib.h>

void double_space(ifstream& f, ofstream& t)
{
   char  c;

   while (f.get(c)) {
      t.put(c);
      if (c == '\n')
	 t.put(c);
   }
}

main(int argc, char** argv)
{
   if (argc != 3) {
      cout << "\nUsage: " << argv[0]
	   <<  "  infile  outfile\n";
      exit(1);
   }

   ifstream  f_in(argv[1]);
   ofstream  f_out(argv[2]);

   if (!f_in) {
      cerr << "cannot open " << argv[1];
      exit(1);
   }
   if (!f_out) {
      cerr << "cannot open " << argv[2];
      exit(1);
   }
   double_space(f_in, f_out);
   return (0);
}
