/*********************************************************************

  Filename:  avg_arr.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.10   Functions - Overloading
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Overload average array functions for doubles and ints
//  Title: avg_array

#include <iostream.h>

double   avg_arr(const double a[], int size);
double   avg_arr(const int a[], int size);

double avg_arr(const int a[], int size)
{
   int  sum = 0;

   for (int i = 0; i < size; ++i)
      sum += a[i];              //performs int arithmetic
   return ((double) sum / size);
}

double avg_arr(const double a[], int size)
{
   double  sum = 0.0;

   for (int i = 0; i < size; ++i)
      sum += a[i];              //performs double arithmetic
   return (sum / size);
}

main()
{
   int    w[5] = {1, 2, 3, 4, 5};
   double x[5] = {1.1, 2.2, 3.3, 4.4, 5.5};

   cout << avg_arr(w, 5) << "  int array average\n";
   cout << avg_arr(x, 5) << "  double array average\n";
   return (0);
}
