/*********************************************************************

  Filename:  stack_p.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.11   Templates
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//template stack implementation
//  Title: stack_parameterized

#include <iostream.h>

enum boolean {false, true};

template <class T>
class stack {
public:
   //the public interface for the ADT stack
   stack() : size(1000)
	{ item = new T[1000]; top = EMPTY; }
   stack(int s) :size(s)
	{ item = new T[s]; top = EMPTY; }
   ~stack() { delete []item; }
   void reset() { top = EMPTY; }
   void push(T c) { item[++top] = c; }
   T& pop() { return (item[top--]); }
   T top_of() { return (item[top]); }
   boolean empty() { return boolean(top == EMPTY); }
   boolean full() { return boolean(top == size - 1); }
private:
   enum  {EMPTY = -1};
   T*    item;
   int   size;
   int   top;
};

typedef stack<char *> str_stack;

main()
{
   str_stack s(100);               // 100 element char stack
   stack<char*>  stk_str(200);     // 200 element char* stack

   cout << "\ntemplate stack popped is ";
   s.push("A");
   cout << s.pop();
   stk_str.push("BCD");
   cout << stk_str.pop();
   cout << endl;
   return (0);
}