/*********************************************************************

  Filename:  strings.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.6    Conversion Rules
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//An implementation of dynamically allocated strings.
//  Title: strings

#include <string.h>
#include <iostream.h>

class string {
public:
   string() { s = new char[1]; s[0] = 0; len = 0; }
   string(const string& str);              //copy constructor
   string(const char* p) { len = strlen(p);
		           s = new char[len + 1];
			   strcpy(s, p); }
   ~string() { delete []s; }
   void assign(const string& str);
   void print() const { cout << s << endl; }
   void concat(const string& a, const string& b);
private:
   char* s;
   int   len;
};

string::string(const string& str)
{
   len = str.len;
   s = new char[len + 1];
   strcpy(s, str.s);
}

void string::assign(const string& str)
{
   delete []s;  //retrieve old string
   len = str.len;
   s = new char[len + 1];
   strcpy(s, str.s);
}

void string::concat(const string& a, const string& b)
{
   len = a.len + b.len;
   delete s;
   s = new char[len + 1];
   strcpy(s, a.s);
   strcat(s, b.s);
}

main()
{
   char*   str = "The wheel that squeaks the loudest\n";
   string  a(str), b, author("Josh Billings\n"), both, quote;

   b.assign("Is the one that gets the grease\n");
   both.concat(a, b);
   quote.concat(both, author);
   quote.print();
   return (0);
}