/*********************************************************************

  Filename:  operplus.cpp
  Chapter:   1      Overview of C++ and Object Oriented Programming
  Section:   1.4    Classes and Abstract Data Types
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Overloading the function print and the operator + .
//  Title:  operator+

#include <string.h>
#include <iostream.h>

const int max_len = 255;

class string {
   char s[max_len];
   int  len;
public:
	void assign(const char* st) { strcpy(s, st); len = strlen(st); }
	int  length() { return (len); }
	void print() { cout << s << "\nLength: " << len << endl; }
	friend string operator +(const string& a, const string& b);
};

string operator +(const string& a, const string& b)   //overload +
{
   string temp;

   temp.assign(a.s);
   temp.len = a.len + b.len;
   if (temp.len < max_len)
      strcat(temp.s, b.s);
   else
      cerr << "Max length exceeded in concatenation.\n";
   return (temp);
}

void print(const char* c)
{
   cout << c << "\nLength: " << strlen(c) << "\n";
}

main()
{
   string      one, two, both;
   char three[40] = {"My name is Charles Babbage."};

   one.assign("My name is Alan Turing.");
   two.assign(three);
   print(three);         //one form of print
   //Print shorter of one and two.
   if (one.length() <= two.length())
      one.print();       //member function form of print
   else
      two.print();
   both = one + two;     //plus overloaded to be concatenate
   both.print();
   return (0);
}

