/*********************************************************************

  Filename:  shape.cpp
  Chapter:   1      Overview of C++ and Object Oriented Programming
  Section:   1.8    Polymorphism
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//shape hierarchy and virtual area() calculation
//  Title: shape

#include <iostream.h>

//shape is an abstract base class
class shape {
public:
   virtual double area() = 0;      //pure virtual function
   virtual char* get_name() = 0;   //pure virtual function
};

class rectangle: public shape {
public:
   rectangle(double h, double w): height(h), width(w) {}
   double area() { return (height * width); }      //overridden function
   char* get_name() { return (" RECTANGLE "); }    //overridden function
private:
   double height, width;
};

class circle: public shape {
public:
   circle(double r): radius(r) {}
   double area() { return ( 3.14159 * radius * radius); }
   char* get_name() { return (" CIRCLE "); }
private:
   double radius;
};

class square: public rectangle {
public:
   square(double h): rectangle(h,h) {}
   double area() { return (rectangle::area()); }
   char* get_name() { return (" SQUARE "); }
};


main()
{
   shape*     ptr_shape;
   rectangle  rec(4.1, 5.2);
   square     sq(5.1);
   circle     cir(6.1);

   cout << "\nThis program uses hierarchies for shapes\n";

   ptr_shape = &rec;
   cout << endl << ptr_shape -> get_name();
   cout << "  area = " << ptr_shape -> area();

   ptr_shape = &cir;
   cout << endl << ptr_shape -> get_name();
   cout << "  area = " << ptr_shape -> area();

   ptr_shape = &sq;
   cout << endl << ptr_shape -> get_name();
   cout << "  area = " << ptr_shape -> area();
}
