/*********************************************************************

  Filename:  student.cpp
  Chapter:   1      Overview of C++ and Object Oriented Programming
  Section:   1.7    OOP and Inheritance
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Title: student

#include <iostream.h>
#include <string.h>

enum support {ta, ra, fellowship, other};
enum year {fresh, soph, junior, senior, grad};

class student {
private:
   int       student_id;
   double    gpa;
   year      y;
   char      name[30];
public:
   student(char* nm, int id, double g, year x);
   void  print();
};

void student::student(char* nm, int id, double g, year x)
{
   strcpy(name, nm);
   student_id = id;
   y = x;
   gpa = g;
}

void student::print()
{
    cout << endl << name << ", " << student_id << ", "
         << y << ", " << gpa << endl;
}

class grad_student : public student {
public:
   grad_student
      (char* nm, int id, double g, year x, support t, char* d, char* th);
   void print();
private:
   support      s;
   char         dept[10];
   char         thesis[80];
};

void grad_student::grad_student
      (char* nm, int id, double g, year x, support t, char* d, char* th)
      : student (nm, id, g, x)
{
   s = t;
   strcpy(dept, d);
   strcpy(thesis, th);
}

void grad_student::print()
{
   student::print();
   cout << dept << ", " << s << endl << thesis << endl;
}

main()
{
   student       s1("Mae Pohl", 214, 92.3, soph);
   grad_student  s2("Morris Pohl", 421, 91.2, grad, ta, "Pharmacy",
                    "Pharmacies as a retail outlet");

   cout << "\nStudent public classes example:\n";

   s1.print();
   s2.print();
}

