/*********************************************************************

  Filename:  tstack.cpp
  Chapter:   1      Overview of C++ and Object Oriented Programming
  Section:   1.9    Templates
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//stack implementation with constructor
//  Title: tstack

#include <iostream.h>

enum boolean { false, true };
template <class T>
class stack {
public:
   stack(int size) { s = new T[size];
                     max_len = size; top = EMPTY; }
   stack(int size, const T str[]);
   stack();
   ~stack() { delete []s; }     //destructor
   void reset() { top = EMPTY; }
   void push(T c) { top++; s[top] = c; }
   T pop() { return( s[top--] ); }
   T top_of() { return( s[top] ); }
   boolean empty() { return (boolean) (top == EMPTY); }
   boolean full() { return (boolean)(top == max_len - 1); }
private:
   enum {EMPTY = -1};
   T *s;
   int  max_len;
   int  top;
};
template <class T>
stack<T>::stack(int size, const T str[])
{
   s = new T[size];
   max_len = size;
   for (int i = 0; i < max_len && str[i] !=0; ++i)
      s[i] = str[i];
   top = --i;
}
template <class T>
stack<T>::stack()
{
   s = new T[100];
   max_len = 100;
   top = EMPTY;
}
typedef stack<char>  stk_char;
main()
{
   stack<char>  typea(100);    //size only
   stack <char>  typeb;         //no size
   stack<char>  typec(50, "My name is Ira Pohl!\n");  //size and initializer
   char reverseline[200];
   char a [30] = {"My name is Laura Pohl!\n"};
   char b [40] = {"My name is Debra Dolsberry!\n"};
	int  i = 0;
   typea.reset();
   while (a[i])
      if (!typea.full())
    typea.push(a[i++]);
   i = 0;
   while (!typea.empty())
      reverseline[i++] = typea.pop();
   reverseline[i] = '\0';
   cout << reverseline;
   i = 0;
   while (b[i])
      if (!typeb.full())
    typeb.push(b[i++]);
   i = 0;
   while (!typeb.empty())
      reverseline[i++] = typeb.pop();
   reverseline[i] = '\0';
   cout << reverseline;
   i = 0;
   while (!typec.empty())
      reverseline[i++] = typec.pop();
   reverseline[i] = '\0';
   cout << reverseline;
   cout << endl;
   stack<int>  int_stk;
   int_stk.push(9);
   cout << int_stk.pop() << endl;
   stack <char*> str_stk;
   str_stk.push("A string");
   cout << str_stk.pop() << endl;
   //stack<stk_char> stk_stk;    stk_stk.push(typea);
   return (0);
}