/*********************************************************************

  Filename:  avg_arr.cpp
  Chapter:   2      C++ as a Better C
  Section:   2.9    Overloading Functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Overload average array functions for doubles and ints
//  Title:  avg_array

#include <iostream.h>

double average(const double a[], int size);
double average(const int a[], int size);
double average(const int a[], const double b[], int size);

double average(const int a[], int size)
{
   int  sum = 0;

   for (int i = 0; i < size; ++i)
      sum += a[i];        //performs int arithmetic
   return ((double) sum / size);
}

double average(const double a[], int size)
{
   double  sum = 0.0;

   for (int i = 0; i < size; ++i)
      sum += a[i];        //performs double arithmetic
   return (sum / size);
}

double average(const int a[], const double b[], int size)
{
   double  sum = 0.0;

   for (int i = 0; i < size; ++i)
      sum += a[i] + b[i];        //performs double arithmetic
   return (sum / size);
}


main()
{
   int    w[5] = {1, 2, 3, 4, 5};
   double x[5] = {1.1, 2.2, 3.3, 4.4, 5.5};

   cout << average(w, 5) << "  int array average\n";
   cout << average(x, 5) << "  double array average\n";
   cout << average(w, x, 5) << "  both arrays averaged\n";
   return (0);
}
