/*********************************************************************

  Filename:  c_stack.cpp
  Chapter:   3      Classes
  Section:   3.3    Structure Pointer Operator: An example: stack
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//A traditional C implementation of type stack.
//  Title: c_stack

#include <iostream.h>

#define max_len  1000
#define EMPTY    -1
#define FULL     (max_len - 1)
enum boolean { false, true };

typedef struct stack {
   char s[max_len];
   int  top;
}stack;

void reset(stack* stk)
{
   stk -> top = EMPTY;
}

void push(char c, stack* stk)
{
   stk -> top++;
   stk -> s[stk -> top] = c;
}

char pop(stack* stk)
{
   return(stk -> s[stk -> top--] );
}

char top(stack* stk)
{
   return(stk -> s[stk -> top] );
}

boolean empty(stack* stk)
{
	return (boolean)(stk -> top == EMPTY);
}

boolean full(stack* stk)
{
	return (boolean)(stk -> top == FULL);
}

main()
{
   stack  s;
   char str[40] = {"My name is Betty Dolsberry!\n"};
   int    i = 0;

   cout << str << "\n";
   reset(&s);
   while (str[i])
      if (!full(&s))
         push(str[i++], &s);
   while (!empty(&s))
      cout << pop(&s);
   cout << "\n";
   return (0);
}
