/*********************************************************************

  Filename:  flush.cpp
  Chapter:   3      Classes
  Section:   3.9    Class Scope: An example: flushing
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//A poker calculation on flushing
//  Title: flush

#include <iostream.h>
#include <stdlib.h>                //for random number
#include <time.h>                  //for random number seed

enum suit { clubs, diamonds, hearts, spades };

class pips {
public:
   void assign(int n) { p = n % 13 + 1; }
   int getpip() { return (p); }
   void print();
private:
   int p;
};

class card {
public:
   suit  s;
   pips  p;
   void assign(int n) { cd = n; s = (suit)(n / 13); p.assign(n); }
   void pr_card();
private:
   int  cd;        //a cd is from 0 to 51
};

class deck {
public:
   void init_deck();
   void shuffle();
   void deal(int, int, card*);
   void pr_deck();
private:
   card d[52];
};

void  deck::init_deck()
{
   for(int i = 0; i < 52; ++i)
      d[i].assign(i);
}

void  deck::shuffle()
{
   for (int i = 0; i < 52; ++i) {
      int k = rand() % 52;
      card t = d[i]; d[i] = d[k]; d[k] = t; //swap two cards
   }
}

void deck::deal(int n, int pos, card *hand)
{
   for(int i = pos; i < pos +n; ++i)
      hand[i - pos] = d[i];
}

main()
{
   card one_hand[9];
   deck dk;
   int  i, j, k, fcnt = 0, sval[4];
   int  ndeal, nc, nhand;
   do {
      cout << "\nEnter no. of cards in each hand (5-9): ";
      cin  >> nc;
   } while (nc < 5 || nc > 9);
   nhand = 52 / nc;

   cout << "\nEnter no. of hands to deal: ";
   cin  >> ndeal;

   randomize();
   dk.init_deck();
   for (k = 0; k < ndeal; k += nhand) {
     if ((nhand + k) > ndeal)
        nhand = ndeal - k;
     dk.shuffle();
     for(i = 0; i < nc * nhand; i += nc) {
        for (j = 0; j < 4; ++j)
           sval[j] = 0;
        dk.deal(nc, i, one_hand);
        for (j = 0; j < nc; ++j)
           sval[one_hand[j].s] ++ ;
        for (j = 0; j < 4; ++j)
          if (sval[j] >= 5)
             fcnt++;
     }
   }
   cout << "\n\nIn " << ndeal << " ";
   cout << nc << "-card hands there were ";
   cout << fcnt << " flushes\n  ";
   return (0);
}
