/*********************************************************************

  Filename:  list_it.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.9    Constructors: An Example:  A Singly Linked List
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//A singly linked list
//  Title: list_it

#include <iostream.h>

struct listelem {           //linked element
   char        data;
   listelem*   next;
};

class list {
public:
   list(): h(0){ }        //0 is the NULL pointer value
   ~list() { release(); }
   void prepend(char c);        //adds to front of list
   void del();
   listelem* first() const { return(h); }
   void print() const;
   void release();
private:
   listelem*  h;
};

void list::del()
{
   listelem* temp = h;
   h = h -> next;
   delete temp;
}


void list::prepend(char c)
{
   listelem* temp = new listelem;  //create new element

   temp -> next = h;               //link to list
   temp -> data = c;
   h = temp;                       //update head of list
}

void list::print() const
{
   listelem*  temp = h;

   while( temp != 0) {           //detect end of list
      cout << temp -> data << " -> ";
      temp = temp -> next;
   }
   cout << "\n###\n";
}

void list::release()     //each element is returned to free store
{
   while (h != 0)
      del();
}

main()
{
   list* p;
   {
      list     w;

      w.prepend('A');
      w.prepend('B');
      w.print();
      w.del();
      w.print();
      p = &w;
      p -> print();
      cout << "exiting inner block" << endl;
   }
   p -> print();  //gives system dependent behavior
   cout << "exiting outer block" << endl;
   return (0);
}
