/*********************************************************************

  Filename:  stack.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.2    Constructing a Dynamically Sized Stack
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//stack implementation with constructor
//  Title: stack

#include <iostream.h>

enum boolean { false, true };

class stack {
public:
   stack(int size) { s = new char[size];
                     max_len = size; top = EMPTY; }
   stack(int size, const char str[]);
   stack();
   ~stack() { delete s;        //destructor
                  cout << "\ndestructor invoked\n"; }
   void reset() { top = EMPTY; }
   void push(char c) { top++; s[top] = c; }
   char pop() { return( s[top--] ); }
   char top_of() { return( s[top] ); }
	boolean empty() { return (boolean) (top == EMPTY); }
	boolean full() { return (boolean)(top == max_len - 1); }
private:
   enum {EMPTY = -1};
   char *s;
   int  max_len;
   int  top;
};


stack::stack(int size, const char str[]) //domain transfer
{
   s = new char[size];
   max_len = size;
   for (int i = 0; i < max_len && str[i] !=0; ++i)
      s[i] = str[i];
   top = --i;
}

stack::stack()
{
   s = new char[100];
   max_len = 100;
   top = EMPTY;
}

main()
{
   stack  typea(100);    //size only
   stack  typeb;         //no size
   stack  typec(50, "My name is Ira Pohl!\n");  //size and initializer

   char reverseline[200];
   char a [30] = {"My name is Laura Pohl!\n"};
   char b [40] = {"My name is Debra Dolsberry!\n"};
   int  i = 0;

   typea.reset();

   while (a[i])
      if (!typea.full())
    typea.push(a[i++]);

   i = 0;
   while (!typea.empty())
      reverseline[i++] = typea.pop();
   reverseline[i] = '\0';
   cout << reverseline;

   i = 0;
   while (b[i])
      if (!typeb.full())
    typeb.push(b[i++]);

   i = 0;
   while (!typeb.empty())
      reverseline[i++] = typeb.pop();
   reverseline[i] = '\0';
   cout << reverseline;

   i = 0;
   while (!typec.empty())
      reverseline[i++] = typec.pop();
   reverseline[i] = '\0';
   cout << reverseline;
   return (0);
}