/*********************************************************************

  Filename:  string.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.6    An Example: Dynamically Allocated Strings XXX Errors
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//An implementation of dynamically allocated strings.
//  Title: dynamic_string

#include <string.h>
#include <iostream.h>

class string {
public:
   string() : len (0) { s = new char[1]; s[0] = 0; }
   string(int n) { s = new char[n + 1l]; len = n; }
   string(const string& str); //copy constructor
   string(const char* p);     //conversion constructor
   ~string() { delete s; }
   void assign(const string& str);
   void print() { cout << s << "\n"; }
   void concat(const string& a, const string& b);
private:
   char* s;
   int   len;
};

string::string(const char* p)
{
   len = strlen(p);
   s = new char[len + 1];
   strcpy(s, p);
}

string::string(const string& str) : len(str.len)
{
   s = new char[len + 1];
   strcpy(s, str.s);
}

void string::assign(const string& str)
{
   if (this == &str)
      return;
   else
      delete []s;  //retrieve old string
   len = str.len;
   s = new char[len + 1];
   strcpy(s, str.s);
}

void string::concat(const string& a, const string& b)
{
   char temp[a.len + b.len + 1];

   len = a.len + b.len;
   strcpy(temp, a.s);
   strcat(temp, b.s);
   delete [] s;
   s = new char[len + 1];
   strcpy(s, temp);
}

main()
{
   char* str = "The wheel that squeaks the loudest\n";
   string  a(str), b, author("Josh Billings\n"), both, quote;

   b.assign("Is the one that gets the grease\n");
   both.concat(a, b);
   quote.concat(both, author);
   quote.print();
   return (0);
}
