/*********************************************************************

  Filename:  twod.h
  Chapter:   4      Constructors and Destructors
  Section:   4.10   Two Dimensional Arrays
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Implementation of a two dimensional safe array type matrix
//MTWO.CPP uses TWOD.H
//  Title: mtwo_dimensional_header

#include <iostream.h>
#include <stdlib.h>

class matrix {
public:
   matrix(int l1, int l2);
   ~matrix();
   int ub1() const { return(s1 - 1); }
   int ub2() const { return(s2 - 1); }
   int& element(int i, int j);
   void mmpy(matrix& a, matrix& b);
private:
   int **p;
   int s1, s2;
};

matrix::~matrix()
{
   for (int i = 0; i <= ub1(); ++i)
      delete p[i];
   delete p;
}

void matrix::mmpy(matrix& a, matrix& b)
{
   int  i, j, k, t;

   for (i = 0; i < a.s1; ++i)
      for (j = 0; j < b.s2; ++j) {
        element(i,j) = 0;
        for (k = 0; k < a.s1; ++k)
           element(i, j) += a.element(i, k) * b.element(k, j);
      }
}

matrix::matrix(int d1, int d2)
{
   if (d1 < 0 || d2 < 0){
      cerr << "illegal matrix size\n";
      exit(1);
   }
   p = new int*[s1];
   for (int i = 0; i < s1; ++i)
      p[i] = new int[s2];
};

int& matrix::element(int i, int j)
{
   if (i < 0 || i > ub1() || j < 0 || j > ub2()) {
      cerr << "illegal matrix index\n";
      exit(1);
   }
   return (p[i][j]);
}
