/*********************************************************************

  Filename:  vect.h
  Chapter:   4      Constructors and Destructors
  Section:   4.8    Members that are class types
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Implementation of a safe array type vect
//Used by Multi_v.CPP
//  Title: multi_vect_header

#include <iostream.h>
#include <stdlib.h>

class vect {
public:
   vect() { size = 100; p = new int[size]; }
   vect(int n);
   vect(vect& v);
   ~vect() { delete [] p;}
   int& element(int i);    //access p[i]
   int ub() const { return (size - 1); }
private:
   int *p;
   int size;
};

vect::vect(int n)
{
   if (n < 0) {
      cerr << "illegal vect size " << n << endl;
      exit(1);
   }
   size = n;
   p = new int[size];
}

vect::vect(vect& v)
{
   size = v.size;
   p = new int[size];
   for (int i = 0; i < size; ++i)
      p[i] = v.p[i];
}

int& vect::element(int i)
{
   if (i < 0 || i >= size) {
      cerr << "illegal vect index " << i << endl;
      exit(1);
   }
   return (p[i]);
}
