/*********************************************************************

  Filename:  overload.cpp
  Chapter:   5      Operator Overloading and Conversions
  Section:   5.3    Overloading and Function Selection
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//overloading functions
//  Title: overloading

#include <iostream.h>
#include <math.h>             //for sqrt

class complex {
public:
   complex(double r) { real = r; imag = 0; }
   void assign(double r, double i) { real = r; imag = i; }
   void print() { cout << real << " + " << imag << "i "; }
   operator double() {return(sqrt(real * real + imag * imag));}
private:
   double real, imag;
};

inline int     greater(int i, int j)
	       { return ( i > j ? i : j); }
inline double  greater(double x, double y)
	       { return ( x > y ? x : y); }
inline complex greater(complex w, complex z)
               { return ( w > z ? w : z); }

main()
{
   int     i = 10, j = 5;
   float   x = 7.0;
   double  y = 14.5;
   complex w(0), z(0), zmax(0);

   w.assign(x, y);
   z.assign(i, j);
   cout << "compare " << i << " and " << j << "  greater is "
        << greater(i, j) << endl;
   cout << "compare " << x << " and " << y << "  greater is "
        << greater(x, y) << endl;
   cout << "compare " << y << " and " ;
   z.print();
   cout << "  greater is " << greater(y, double(z)) << endl;
   zmax = greater(w, z);
   cout << "compare ";
   w.print();
   cout << "  and  ";
   z.print();
   cout << "  greater is  ";
   zmax.print();
   cout << endl;
   return (0);
}