/*********************************************************************

  Filename:  binaryse.cpp
  Chapter:   6      Inheritance
  Section:   6.4    Code Reuse: A Binary Tree Class
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//generic binary search trees
//  Title: binary_search_tree

#include <string.h>
#include <iostream.h>

typedef void*   p_gen;   //generic pointer type

class bnode {
private:
   friend  class gen_tree;
   bnode*  left;
   bnode*  right;
   p_gen   data;
   int     count;
   bnode(p_gen d, bnode* l, bnode* r)
        :data(d),left(l),right(r),count(1){}
   friend int comp(p_gen a, p_gen b);
   friend void print(bnode* n);
};

class gen_tree {
public:
   gen_tree() { root = 0; }
   void insert(p_gen d);
   p_gen find(p_gen d) { return (find(root, d)); }
   void print() { print(root); }
protected:
   bnode* root;
   p_gen find(bnode* r, p_gen d) const;
   void print(bnode* r) const;         //needs to be aux fcn
};

void gen_tree::insert(p_gen d)
{
   bnode* temp = root;
   bnode* old;

   if (root == 0) {
      root = new bnode(d, 0, 0);
      return;
   }
   while (temp != 0) {
      old = temp;
      if (comp(temp -> data, d) == 0) {
	 (temp -> count)++;
	 return;
      }
      if (comp(temp -> data, d) > 0)
	 temp = temp -> left;
      else
	 temp = temp -> right;
   }
   if (comp(old -> data, d) > 0)
      old -> left = new bnode(d, 0, 0);
   else
      old -> right = new bnode(d, 0, 0);
}

p_gen gen_tree::find(bnode* r, p_gen d) const
{
   if (r == 0)
      return (0);
   else if (comp(r -> data, d) ==  0)
      return (r -> data);
   else if (comp(r -> data, d) > 0)
      return (find( r -> left, d));
   else
      return (find( r -> right, d));
}

void gen_tree::print(bnode* r) const
{
   if (r != 0) {
      print (r -> left);
      ::print(r);
      print (r -> right);
   }
}


class s_tree : private gen_tree {
public:
   s_tree() {}
   void  insert(char* d) { gen_tree::insert(p_gen(d)); }
   char* find(char* d) const
	 { return ((char*)gen_tree::find(p_gen(d))); }
   void  print() const { gen_tree::print(); }
};

int comp(p_gen i, p_gen j)
{
   return (strcmp((char*)i, (char*)j));
}

void print(bnode* n)
{
   cout << (char*)n -> data << "\t" ;
   cout << n -> count << "\t";
}

main()
{
   s_tree t;
   char   dat[80], *p;

   cout << "\nEnter strings; exit with an end-of-file\n";
   while ( cin >> dat && cin.good()) {
      p = new char[strlen(dat) + 1];
      strcpy(p, dat);
      t.insert(p);
   }
   t.print();
   cout << endl;
   return (0);
}
