/*********************************************************************

  Filename:  shape.cpp
  Chapter:   6      Inheritance
  Section:   6.5    Virtual Functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//shape hierarchy and virtual area() calculation
//  Title: shape

#include <iostream.h>

const PI = 3.14159;

class shape {
public:
   virtual double area() const  { return (0); } //default behavior
   virtual char* get_name() = 0;
protected:
   double x, y;
};

class rectangle: public shape {
public:
   rectangle(double h, double w): height(h), width(w) {}
   double area() const { return (height * width); }
   char* get_name() { return (" RECTANGLE "); }
private:
   double height, width;
};

class circle: public shape {
public:
   circle(double r): radius(r) {}
   double area() const { return (PI * radius * radius); }
   char* get_name() { return (" CIRCLE "); }
private:
   double radius;
};

class square: public rectangle {
public:
   square(double h): rectangle(h,h) {}
   double area() { return (rectangle::area()); }
   char* get_name() { return (" SQUARE "); }
};


main()
{
   shape*     ptr_shape;
   rectangle  rec(4.1, 5.2);
   square     sq(5.1);
   circle     cir(6.1);

   cout << "\nThis program uses hierarchies for shapes\n";

   ptr_shape = &rec;
   cout << endl << ptr_shape -> get_name();
   cout << "  area = " << ptr_shape -> area();

   ptr_shape = &cir;
   cout << endl << ptr_shape -> get_name();
   cout << "  area = " << ptr_shape -> area();

   ptr_shape = &sq;
   cout << endl << ptr_shape -> get_name();
   cout << "  area = " << ptr_shape -> area();
   return (0);
}