/*********************************************************************

  Filename:  student.cpp
  Chapter:   6      Inheritance
  Section:   6.1    A Derived Type
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Title: student

#include <iostream.h>
#include <string.h>

enum year {fresh, soph, junior, senior, grad};
enum support {ta, ra, fellowship, other};

class student {
public:
   student(char* nm, int id, double g, year x);
   void  print() const;
protected:
   int       student_id;
   double    gpa;
   year      yr;
   char      name[30];
};

class grad_student : public student {
public:
   grad_student
      (char* nm, int id, double g, year x, support t, char* d, char* th);
   void print() const;
protected:
   support      s;
   char         dept[10];
   char         thesis[80];
};

student::student(char* nm, int id, double g, year x)
		:student_id(id), gpa(g), yr(x)
{
   strcpy(name, nm);
}


grad_student::grad_student(
   char* nm, int id, double g, year x,
   support t, char* d, char* th)
   :student(nm, id, g, x), s(t)
{
   strcpy(dept, d);
   strcpy(thesis, th);
}

void student::print() const
{
   cout << "\n" << name << " , " << student_id << " , "
	<< yr << " , " << gpa << endl;
}

void grad_student::print() const
{
   student::print();
   cout << dept << " , " << s << "\n" << thesis << endl;
}

//Test pointer conversion rules.

main()
{
   student        s("Mae Pohl", 100, 3.425, fresh), *ps = &s;
   grad_student   gs("Morris Pohl", 200, 3.2564, grad, ta, "Pharmacy",
		    "Retail Pharmacies"), *pgs;

   ps -> print();
   ps = pgs = &gs;
   ps -> print();
   pgs -> print();    //grad_student::print
   return (0);
}
