/*********************************************************************

  Filename:  stack_p.cpp
  Chapter:   7      Templates
  Section:   7.1    Template Class Stack
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//template stack implementation
//  Title: stack_parameterized

#include <iostream.h>

enum boolean {false, true};

template <class TYPE>
class stack {
public:
   //the public interface for the ADT stack
   stack() :max_len(1000), top(EMPTY)
	{ s = new TYPE[1000]; }
   stack(int size) :max_len(size), top(EMPTY)
	{ s = new TYPE[size]; }
   ~stack() { delete [] s; }
   void reset() { top = EMPTY; }
   void push(TYPE c) { s[++top] = c; }
   TYPE pop() { return (s[top--]); }
   TYPE top_of() const { return (s[top]); }
   boolean empty() const { return boolean(top == EMPTY); }
   boolean full() const { return boolean(top == max_len - 1); }
private:
   enum  {EMPTY = -1};
   TYPE* s;
   int   max_len;
   int   top;
};

//Reversing a series of char* represented strings
void reverse(char* str[], int n)
{
   stack<char*> stk(n);

   for (int i = 0; i < n; ++i)
      stk.push(str[i]);
   for (i = 0; i < n; ++i)
      str[i] = stk.pop();
}

main()
{
   stack<char>   stk_ch;           // 1000 element char stack
   stack<char*>  stk_str(200);     // 200 element char* stack
   char*         str_series[] = {"first string ", "second string ",
                                 "third string ", "last string "};

   cout << "\ntemplate stack popped is ";
   stk_ch.push('A');
   cout << stk_ch.pop();
   stk_str.push("BCD");
   stk_str.push("ANOTHER");
   cout << stk_str.pop();
   cout << endl;
   reverse(str_series, 3); //reverse 1st 3 strings, leave last in place
   cout << str_series[0] << str_series[1]
        << str_series[2] << str_series[3] << endl;
   return (0);
}