/*********************************************************************

  Filename:  vect2.h
  Chapter:   8      Exceptions
  Section:   8.1    Using assert.h
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Implementation of a safe array type vect
//  Title: vect2_assert_header

//This header file is used by vect2.cpp

#include <iostream.h>
#include <stdlib.h>     //for exit
#include <assert.h>     //for assertions

class vect {
public:
   vect() { size = 10; p = new int[size]; }
   vect(int n);
   ~vect() { delete [] p; }
   int& element(int i);    //access p[i]
   int  ub() const { return (size - 1); }   //upper bound
private:
   int* p;
   int  size;
};

vect::vect(int n)
{
   assert (n > 0);  //contractual precondition
   size = n;
   p = new int[size];
   assert (p != 0); //contractual postcondition
}


int& vect::element(int i)
{
   if (i < 0 || i >= size) {
      cerr << "illegal vect index " << i << endl;
      exit(1);
   }
   return (p[i]);
}